{-------------------------------------------------------------------------------
   Purpose: Esimerkki yksinkertaisesta lomakkeesta jossa on muutama nappula
   Unit:    AutolaskuriForm
   Author:  vesal
   Date:    14.9.2003
   Changed: Pieni lisyksi esimerkkeihin. /MN, 16.4.2004
-------------------------------------------------------------------------------}
unit AutolaskuriForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TFormAutolaskuri = class(TForm)
    ButtonNollaa: TButton;
    ButtonHA: TButton;
    LabelHA: TLabel;
    ButtonKA: TButton;
    LabelKA: TLabel;
    ImageHA: TImage;
    TimerKA: TTimer;
    ButtonMonista: TButton;
    LabelNopeus: TLabel;
    TBKaasu: TTrackBar;
    ButtonLuoLabel: TButton;
    PanelUudet: TPanel;
    ButtonVanhenna: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    ButtonVapauta: TButton;
    procedure ButtonHAClick(Sender: TObject);
    procedure ButtonKAClick(Sender: TObject);
    procedure ButtonNollaaClick(Sender: TObject);
    procedure TimerKATimer(Sender: TObject);
    procedure ButtonMonistaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TBKaasuChange(Sender: TObject);
    procedure ButtonLuoLabelClick(Sender: TObject);
    procedure ButtonVanhennaClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonVapautaClick(Sender: TObject);
  private
    { Private declarations }
//    FNopeus : integer;  // W
    labely : integer;
    procedure SetNopeus(n:integer);
    function GetNopeus():integer;

  public
{ Public declarations }
end;

var
FormAutolaskuri: TFormAutolaskuri;

implementation

{$R *.dfm}

procedure lisaa(lab:TLabel; n:integer);
begin
  lab.Caption := IntToStr(StrToIntDef(lab.Caption,0)+n);
end;

procedure TFormAutolaskuri.ButtonHAClick(Sender: TObject);
begin
  lisaa(LabelHA,1);
end;

procedure TFormAutolaskuri.ButtonKAClick(Sender: TObject);
begin
  lisaa(LabelKA,1);
end;

procedure TFormAutolaskuri.ButtonNollaaClick(Sender: TObject);
begin
  LabelHA.Caption := '0';
  LabelKA.Caption := '0';
end;


procedure TFormAutolaskuri.TimerKATimer(Sender: TObject);
begin
  if ( ImageHA.Left >= ClientWidth - ImageHA.Width - GetNopeus()) then
    SetNopeus(-Abs(GetNopeus()));
  if ( ImageHA.Left <= 0 - GetNopeus()) then
    SetNopeus(Abs(GetNopeus()));
  ImageHa.Left := ImageHa.Left + GetNopeus();
end;

procedure TFormAutolaskuri.ButtonMonistaClick(Sender: TObject);
var f : TFormAutolaskuri;
begin
  // dynaaminen lomakkeen luonti (vrt. luonti projektitiedostossa)
  f := TFormAutolaskuri.Create(self);

  // 'globaalin' lomakkeen luonti (sovellus vastaa poistamisesta):
//  f := TFormAutolaskuri.Create(Application);

  // siirretn uutta ikkunaa, muuten menisi pllekkin
  f.Left:=self.Left+20;
  f.Top:=self.Top+20;
  f.Show();
end;

procedure TFormAutolaskuri.FormCreate(Sender: TObject);
begin
  SetNopeus(10);
end;

procedure TFormAutolaskuri.TBKaasuChange(Sender: TObject);
begin
  SetNopeus(TBKaasu.Position);
end;

function TFormAutolaskuri.GetNopeus: integer;
begin
//  Result := FNopeus;
  Result := ImageHA.Tag;
end;

procedure TFormAutolaskuri.SetNopeus(n: integer);
begin
//  FNopeus := n;
  ImageHA.Tag := n;
  LabelNopeus.Caption := IntToStr(GetNopeus());
  TBKaasu.Position := GetNopeus();
end;

procedure TFormAutolaskuri.ButtonLuoLabelClick(Sender: TObject);
var lab : TLabel;
begin
  lab := TLabel.Create(self);   // self: lomake omistaa labelin
//  lab := TLabel.Create(PanelUudet); // paneeli omistaa labelin
  lab.Parent := PanelUudet; // label luodaan paneeliin
  lab.Caption := 'Uusi';
  lab.Top := labely + 10;
  labely := labely + lab.Height;
  lab.Left := 10;
end;

procedure TFormAutolaskuri.ButtonVanhennaClick(Sender: TObject);
var i:integer; c : TControl;  lab : TLabel; co : TComponent;
begin
//  Vanhennetaan ne labelit jotka asuu panelin pll
(*  for i:=0 to PanelUudet.ControlCount-1 do begin
    c := PanelUudet.Controls[i];
    if  ( not ( c is TLabel ) ) then continue;
    lab := TLabel(c);
    if ( lab.Caption = 'Uusi' ) then lab.Caption := 'Vanha';
  end;
  *)

// Vanhennetaan ne labelit jotka asuu form pll
 (* for i:=0 to ControlCount-1 do begin
    c := Controls[i];
    if  ( not ( c is TLabel ) ) then continue;
    lab := TLabel(c);
    if ( lab.Caption = 'Uusi' ) then lab.Caption := 'Vanha';
  end; *)

//  Vanhennetaan ne labelit jotka lomake omistaa
  for i:=0 to ComponentCount-1 do begin
    co := Components[i];
    if  ( not ( co is TLabel ) ) then continue;
    lab := TLabel(co);
    if ( lab.Caption = 'Uusi' ) then lab.Caption := 'Vanha';
  end;

end;

procedure TFormAutolaskuri.Edit1Change(Sender: TObject);
begin
  lisaa(LabelHA,1);
end;

procedure TFormAutolaskuri.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree; // vapautetaan lomake ja sen omistamat lomakkeet.
  (*
     huom. oletuksena lomake ainoastaan piilotetaan
     ja vapautetaan lopetettaessa koko sovellus *)
end;

procedure TFormAutolaskuri.ButtonVapautaClick(Sender: TObject);
var i:integer;
begin
  // formin omistamien lomakkeiden vapautus
  for i:=0 to ComponentCount-1 do begin
    if (Components[i] is TForm) then begin
      (Components[i] as TForm).Release;
      (*
        release varmistaa, ett kesken olevat tapahtumat
        ksitelln ja vapauttaa sitten lomakkeen.
        lomakkeita ei saa vapauttaa Free-metodilla! *)
    end;
  end;
end;

end.

